#include <allegro.h>
#include <stdlib.h>
#include <string.h> /* [CLD: added for strcat] */
#include <time.h>
#include <stdio.h>

#define MOVES_PADDING 2 // give the player this many more moves than "necessary"
#define MIN_DIFFICULTY 0 // for sissies, and players just starting
#define MAX_DIFFICULTY 50 // GOOD LORD that's difficult!

#define NUM_NODES 10
#define ROWS 16
#define COLS 11
#define TILE_S 64
#define M(X,Y) (map[X][Y]!=GRASS)

enum {TS_CPU,TS_JP,TS_SHROOMS,TILESET_NUM}; // [CLD: multiple tileset support]

enum {GRASS,GEN,NODE,HORIZ,VERT,LU,DL,UR,RD,U3,R3,D3,L3,FOUR,TILENUM}; 
BITMAP *node[TILENUM];
BITMAP *bkg;
BITMAP *db;
BITMAP *mouse_pointer,*mouse_pointer_prev_overdraw;

int pathdraw;
int k,l,c;
int tileset;
int difficulty;
int moves;

int m[NUM_NODES],n[NUM_NODES];

#define DB2S \
   { \
   int mx=mouse_x-32,my=mouse_y-32; /* so it won't change between overdraw and topdraw */ \
	 /* -32 from each to keep it centered */ \
   blit(db,mouse_pointer_prev_overdraw,mx,my,0,0,64,64); /* get underneath */ \
   masked_blit(mouse_pointer,db,0,0,mx,my,64,64); /* draw cursor */ \
	 blit(db,screen,0,0,0,0,SCREEN_W,SCREEN_H); \
   blit(mouse_pointer_prev_overdraw,db,0,0,mx,my,64,64); /* redraw underneath */ \
   }

int redraw;
int map[ROWS][COLS];
int mapcon[ROWS][COLS];

int restmove=0;
int restcap=3;

// [CLD: removed the passing of map[][] everywhere, since it's global now]
void algorithm();
void buildpath(); // formerly labelled drawpath
void makepathpretty(); // formerly labelled ispath
void drawmap();
void prune();
void drawslidingpiece(BITMAP *bmp, int x,int y,int d); // formerly labelled drawfirst
void mapscramble(int num, int range);
int updatecon();
void spreadfrom(int a,int b,int prev_a,int prev_b);

/*
void loadAssets(int setNumber);

void loadAssets(int setNumber) /* setNumber is from 0-26
 {
	char *filename[50];
	strcpy(filename,"A\\tl.bmp");
	filename[0]+=setNumber; // increment folder letter
	if(NODE[TL]!=NULL)
		destroy_bitmap(NODE[TL]);
	NODE[TL]=load_bmp(filename,NULL);
	strcpy(filename,"A\\tr.bmp");
	filename[0]+=setNumber;
	if(NODE[TR]!=NULL)
		destroy_bitmap(NODE[TR]);
	NODE[TR]=load_bmp(filename,NULL);

 /* etc. etc. 
 } 
*/

void spreadfrom(int a,int b,int prev_a,int prev_b)
  {
  int prev=map[prev_a][prev_b];
	int u=0,r=0,d=0,l=0;
	if(mapcon[a][b] || map[a][b]==GRASS)
		return;
	if(prev_b==b+1)
  	switch (prev)//UPS
    	{
    	case GEN:
    	case NODE:
    	case VERT:
    	case LU:
    	case UR:
    	case U3:
    	case R3:
    	case L3:
    	case FOUR:
    		u=1;
    	}
	if(prev_a==a-1)
  	switch (prev)//RIGHTS
    	{
    	case GEN:
    	case NODE:
    	case HORIZ:
    	case UR:
    	case RD:
    	case U3:
    	case R3:
    	case D3:
    	case FOUR:
    		r=1;
    	}
	if(prev_b==b-1)
  	switch (prev)//DOWNS
    	{
    	case GEN:
    	case NODE:
    	case VERT:
    	case DL:
    	case RD:
    	case R3:
    	case D3:
    	case L3:
    	case FOUR:
    		d=1;
    	}
	if(prev_a==a+1)
  	switch (prev)//LEFTS
    	{
    	case GEN:
    	case NODE:
    	case HORIZ:
    	case LU:
    	case DL:
    	case U3:
    	case D3:
    	case L3:
    	case FOUR:
    		l=1;
    	}
    	
	////////////////////
	int happy=0;

  if(prev_a==a && prev_b==b) // for starting generator
    happy=1;

	if(d/* && prev_b==b-1*/)
  	switch (map[a][b])//UPS
    	{
    	case GEN:
    	case NODE:
    	case VERT:
    	case LU:
    	case UR:
    	case U3:
    	case R3:
    	case L3:
    	case FOUR:
    		happy=1;
    	}
	if(l/* && prev_a==a+1*/)
  	switch (map[a][b])//RIGHTS
    	{
    	case GEN:
    	case NODE:
    	case HORIZ:
    	case UR:
    	case RD:
    	case U3:
    	case R3:
    	case D3:
    	case FOUR:
    		happy=1;
    	}
	if(u/* && prev_b==b+1*/)
  	switch (map[a][b])//DOWNS
    	{
    	case GEN:
    	case NODE:
    	case VERT:
    	case DL:
    	case RD:
    	case R3:
    	case D3:
    	case L3:
    	case FOUR:
    		happy=1;
    	}
	if(r/* && prev_a==a-1*/)
  	switch (map[a][b])//LEFTS
    	{
    	case GEN:
    	case NODE:
    	case HORIZ:
    	case LU:
    	case DL:
    	case U3:
    	case D3:
    	case L3:
    	case FOUR:
    		happy=1;
    	}
	if(!happy)
	  return;
	////////////////////
	mapcon[a][b]=1;
	if(map[a][b]==NODE)
	  {      
		c++;
    if(pathdraw)
      {
      circlefill(screen,a*64+32,b*64+32,32,makecol(255,255,0));
      rest(20);
      }
    }

	switch (map[a][b])//UPS
  	{
  	case GEN:
  	case NODE:
  	case VERT:
  	case LU:
  	case UR:
  	case U3:
  	case R3:
  	case L3:
  	case FOUR:
  		if(b-1>=0)
  			spreadfrom(a,b-1,a,b);
  	}
	switch (map[a][b])//RIGHTS
  	{
  	case GEN:
  	case NODE:
  	case HORIZ:
  	case UR:
  	case RD:
  	case U3:
  	case R3:
  	case D3:
  	case FOUR:
  		if(a+1<=ROWS-1)
  			spreadfrom(a+1,b,a,b);
  	}
	switch (map[a][b])//DOWNS
  	{
  	case GEN:
  	case NODE:
  	case VERT:
  	case DL:
  	case RD:
  	case R3:
  	case D3:
  	case L3:
  	case FOUR:
  		if(b+1<=COLS-1)
  			spreadfrom(a,b+1,a,b);
  	}
	switch (map[a][b])//LEFTS
  	{
  	case GEN:
  	case NODE:
  	case HORIZ:
  	case LU:
  	case DL:
  	case U3:
  	case D3:
  	case L3:
  	case FOUR:
  		if(a-1>=0)
  			spreadfrom(a-1,b,a,b);
  	}
  }

int updatecon()
  {
	for(int i=0;i<ROWS;i++)
		for(int j=0;j<COLS;j++)
			mapcon[i][j]=0;

	c=0;
	spreadfrom(k,l,k,l);

	while(key[KEY_R])
    {
    textprintf(screen, font, 5, 5, makecol(255,255,255), "%i of %i",c,NUM_NODES);
    rest(250);
    }
	return (c==NUM_NODES);
  }


void drawslidingpiece(BITMAP *bmp, int x,int y,int d)
  {
	blit (db,screen,x-10,y-10,x-10,y-10,TILE_S+20,TILE_S+20);
	draw_sprite(screen,node[d],x,y);
	if(restmove++ > restcap)
  	{
		rest(1);
		restmove=0;
  	}
  }

void mapscramble(int num, int range)
  {
	drawmap();
	DB2S;
	int tx, ty,tx2,ty2; 
	  /* [CLD: added !updatecon() to avoid stopping on a map that's already done] */
	while((num>0 && !key[KEY_F11]) || updatecon())
  	{
		tx=rand()%ROWS;
		ty=rand()%COLS;
		if(map[tx][ty] != GRASS && map[tx][ty] != GEN && map[tx][ty] != NODE)
  		{			
			tx2=tx+rand()%range;
			tx2 -= rand()%range;
			ty2=ty+rand()%range;
			ty2 -= rand()%range;
			if(tx2 >= 0 && tx2 <= ROWS-1 && ty2 >= 0 && ty2 <= COLS-1 && 
				         map[tx2][ty2] != GEN && map[tx2][ty2] != NODE)
  			{
				num--;
				restcap=(1 + (abs(tx-tx2) + abs(ty-ty2))/5)*20;
				DB2S;
				int tmp_first=map[tx][ty],tmp_second=map[tx2][ty2];
				map[tx][ty]=GRASS;
				drawmap();
				if(tmp_first != GRASS && !key[KEY_ESC])
					do_line(db, tx*64, ty*64, tx2*64, ty2*64, tmp_first, drawslidingpiece);

				map[tx2][ty2]=tmp_first;
				drawmap();
				if(tmp_second != GRASS && !key[KEY_ESC])
					do_line(db, tx2*64,ty2*64,tx*64, ty*64,tmp_second,drawslidingpiece);	

				map[tx][ty]=tmp_second;
				if(!key[KEY_ESC])
				  {
   				drawmap();
				  DB2S;
          }
  			}
  		}
  	}
  }

int main(int argc, int *argv[])
  {
  allegro_init();
  	
  srand(time(NULL));
  install_keyboard();
  set_color_depth(16);
  
  if(set_gfx_mode(GFX_AUTODETECT, 1024,768,0,0)) // try this first
    {
    int w,h;
    if(get_desktop_resolution(&w, &h)==0) // otherwise, try using desktop res
      {
      if(w>=1024 && h>=768) // larger than we need? at least?
      	set_gfx_mode(GFX_AUTODETECT, w,h,0,0); // oh well, use it anyhow
      else
        {// we don't have high enough res
        char popupmessage[70];
        sprintf(popupmessage,"%d x %d is too low. SA Requires 1024x768 or greater.", w, h); 
  	    allegro_message(popupmessage);
  	    allegro_exit();
    	  exit(0);
        }
      }
    }  
    
  text_mode(-1); // [CLD: removes black boxes from around letters]

  install_mouse();  
  show_mouse (NULL);

  /*
  Allegro's show_mouse(anything) is a little buggy, so instead we'll just draw
  the cursor ourselves in software mode (i.e. as bitmaps).  I've commented out
  future uses of the show_mouse calls, in favor of just drawing the mouse prior
  to screen redraw each frame, inside the DB2S macro
  */
  // [CLD:added mouse_pointer_prev_overdraw to only redraw 'underneath' spot]
  mouse_pointer_prev_overdraw=create_bitmap(64,64);
  mouse_pointer=create_bitmap(64,64);
  rectfill(mouse_pointer, 3, 3, 80, 80, makecol(255,0,255));
  rect(mouse_pointer, 0, 0, 63, 63, makecol( 0, 0, 0));
  rect(mouse_pointer, 1, 1, 62, 62, makecol( 0, 0, 0));
  rect(mouse_pointer, 2, 2, 61, 61, makecol( 0, 0, 0));
  circlefill (mouse_pointer, 32, 32, 2, makecol(0,0,0));
  set_mouse_sprite(mouse_pointer);
  set_mouse_sprite_focus(32, 32);
  int click=0;
  int needs_new_map=1;
  
  for(int i=0;i<TILENUM;i++)
		node[i]=NULL;

	bkg=NULL;
  db=create_bitmap(SCREEN_W,SCREEN_H);

  int tx,ty,tx2,ty2;
  pathdraw=0;
  redraw=1;
  tileset=rand()%TILESET_NUM;
  difficulty=0;
  //game routine
  while(!key[KEY_ESC])
    {
  	if(needs_new_map)
    	{
      click=0;
      moves=0;
  		algorithm();
  		mapscramble(4+difficulty,3+difficulty);
  		needs_new_map=0;
  		redraw=1;
  		//pathdraw=0; // [CLD: leave hint mode on if that's what they want]
  		tileset=rand()%TILESET_NUM;
    	}
  	if(key[KEY_F1])
    	{
  		while(key[KEY_F1]);
  		difficulty-=4;
  		if(difficulty<MIN_DIFFICULTY)
  			difficulty=MIN_DIFFICULTY;  			
    	needs_new_map=1;
    	}
  	if(key[KEY_F2])
    	{
  		while(key[KEY_F2]);
  		difficulty+=4;
   		if(difficulty>MAX_DIFFICULTY) 
  			difficulty=MAX_DIFFICULTY;
      needs_new_map=1;  			
    	} 
  	if(key[KEY_SPACE])
     	{
  		while(key[KEY_SPACE]);
  		needs_new_map=1;
    	}
  	
  	if(key[KEY_F3])
    	{
  		while(key[KEY_F3]);
  		if(pathdraw)
    		{
  			pathdraw=0;
  			redraw=1;
    		}
  		else
    		{
  			pathdraw=1;
  			redraw=1;
    		}
    	}
  	
  	if(moves>4+MOVES_PADDING+difficulty)
      {      
      drawmap();
      DB2S
      int len=text_length(font,"BETTER LUCK NEXT TIME!")+15;
      int hei=text_height(font)+15;
			rectfill(screen,(SCREEN_W-len)>>1,(SCREEN_H-hei)>>1,
			   (SCREEN_W+len)>>1,(SCREEN_H+hei)>>1,0);
			textout_centre(screen,font,"BETTER LUCK NEXT TIME!",SCREEN_W>>1,
          (SCREEN_H-text_height(font))>>1,makecol(255,0,0));
      rest(500);
      for(int i=0;i<1500;i++)
        {
        if(mouse_b || key[KEY_SPACE])
          {
          while(mouse_b || key[KEY_SPACE]); // avoid an accidental move
          break;
          }
        rest(1);
        }        
      if(difficulty > MIN_DIFFICULTY) // [CLD: when they lose, make it easier]
          difficulty--;
  			
      needs_new_map=1;
      redraw=1;
      }  	  	
    else if(redraw)
    	{ 		
  		if(updatecon())
    		{
        if(!pathdraw)
          {
          pathdraw=1; // turn it on long enough to show connection chain
          drawmap();
          pathdraw=0;
          }
        else
          drawmap();
        DB2S
        int len=text_length(font,"YOU ARE A WINNER!")+15;
        int hei=text_height(font)+15;
  			rectfill(screen,(SCREEN_W-len)>>1,(SCREEN_H-hei)>>1,
  			   (SCREEN_W+len)>>1,(SCREEN_H+hei)>>1,
           makecol(255,255,0));
  			textout_centre(screen,font,"YOU ARE A WINNER!",SCREEN_W>>1,
                (SCREEN_H-text_height(font))>>1,0);
        rest(500);
        for(int i=0;i<1500;i++)
          {
          if(mouse_b || key[KEY_SPACE])
            {
            while(mouse_b || key[KEY_SPACE]); // avoid an accidental move
            break;
            }
          rest(1);
          }
        if(difficulty < MAX_DIFFICULTY) // [CLD: when they win, make it more challenging]
          difficulty++;  
  			needs_new_map=1;
    		}  
    	else // [CLD: call drawmap _after_ updatecon, so that hints aren't 1 step behind]
    	  {
        drawmap();
    		if(click != 0)
      		{
    			rect(db, tx*64, ty*64,tx*64+64 ,ty*64+64 , makecol(0,0,0));
    			rect(db, tx*64+1, ty*64+1,tx*64+64-1 ,ty*64+64-1 , makecol(255,255,255));
    			rect(db, tx*64+2, ty*64+2,tx*64+64-2 ,ty*64+64-2 , makecol(0,0,0));
      		}
        }
  		redraw=0;
    	}
  
  	//rect(screen, mouse_x-(mouse_x%64), mouse_y-(mouse_y%64),mouse_x-(mouse_x%64)+64 ,mouse_y-(mouse_y%64)+64 , makecol(0,0,0));
  	//MOUSE CLICK ROUTINE
  	if(mouse_b)
    	{
  		while(mouse_b);
  		if(click<1)
    		{
  			tx=mouse_x/64;
  			ty=mouse_y/64;
  			// [CLD: checking tx and ty bounds to ensure we didn't click status bar]
  			if(tx<ROWS && ty<COLS && map[tx][ty] != NODE && map[tx][ty] != GEN)
  				click++;
    		}
  		else 
    		{
  			tx2=mouse_x/64;
  			ty2=mouse_y/64;
  			  // [CLD: checking tx2 and ty2 bounds to ensure we didn't click status bar]
  			if(tx2<ROWS && ty2<COLS && map[tx2][ty2] != NODE && map[tx2][ty2] != GEN)
    			{	
          if(!(tx==tx2 && ty2==ty) &&
             !(map[tx][ty]==GRASS && map[tx2][ty2]==GRASS))
            moves++;
  				restcap=1 + (abs(tx-tx2) + abs(ty-ty2))/2;
  				DB2S;
  				int tmp_first=map[tx][ty],tmp_second=map[tx2][ty2];
  				click=0;
  				map[tx][ty]=GRASS;
  				drawmap();
  				if(tmp_first != GRASS)
  					do_line(db, tx*64, ty*64, tx2*64, ty2*64, tmp_first, drawslidingpiece);
  
  				map[tx2][ty2]=tmp_first;
  				drawmap();
  				if(tmp_second != GRASS)
  					do_line(db, tx2*64,ty2*64,tx*64, ty*64,tmp_second,drawslidingpiece);	
  
  				map[tx][ty]=tmp_second;
    			}
    		}
  		redraw=1;
    	}  	
  	DB2S
    }
  remove_mouse();

  destroy_bitmap(db);
  destroy_bitmap(mouse_pointer);
  destroy_bitmap(mouse_pointer_prev_overdraw);
  allegro_exit();
  return 0;
  } END_OF_MAIN();

#define MAKE_ROT_MACRO(TARGET,SRC,ANG) \
	node[TARGET]=create_bitmap(TILE_S,TILE_S); \
	rectfill(node[TARGET],0,0,TILE_S,TILE_S,makecol(255,0,255)); \
	rotate_sprite(node[TARGET],node[SRC],0,0,itofix(ANG));

void drawmap()
  {    
	if(bkg)
	  blit(bkg,db,0,0,0,0,1024,704);
	
  for(int i=0;i<ROWS;i++)
    {
  	for(int j=0;j<COLS;j++)
    	{
  		if(!bkg)
  			blit(node[GRASS], db, 0,0,TILE_S*i,TILE_S*j,TILE_S,TILE_S);
  		//readkey();
  		if(map[i][j]!=GRASS)
  			masked_blit(node[map[i][j]], db, 0,0,TILE_S*i,TILE_S*j,TILE_S,TILE_S);//Draw from 0,0 to 50,50 on the screen at (0,0)
  		if(pathdraw && mapcon[i][j])
  			rect(db,i*64+1,j*64+1,i*64+TILE_S-1,j*64+TILE_S-1,makecol(255,255,0));			
    	}
    }
  
  rectfill(db,400,720,1020,740,0); // erase area behind changing numbers
  textprintf(db,font,170, 720,-1,"SPACEBAR : New Map     F1 : -4 levels     F3 : Toggle Help Mode    Moves Used : %i",moves); 
  textprintf(db,font,170, 730,-1,"ESCAPE : Quit          F2 : +4 levels     Current Level : %2d       Moves Allowed : %i ",difficulty,4+MOVES_PADDING+difficulty);
  textout_centre(db,font,"Swapping Action Dev Team: David Hartunian, Justin Lokey, Jeff Baxendale, Keisha How",SCREEN_W>>1, 750,makecol(160,160,160));
  }

void algorithm()
  {	
	if(bkg!=NULL)
  	{	
		destroy_bitmap(bkg);
		bkg=NULL;
  	}

	for(int i=0;i<TILENUM;i++)
  	{
		if(node[i]!=NULL)
  		{
			destroy_bitmap(node[i]);
			node[i]=NULL;
  		}
  	}

	char base[10],fullname[35];
  switch(tileset)
  	{
    case TS_JP:
      strcpy(base,"dino\\");
      break;
    case TS_CPU:
      strcpy(base,"cpu\\");
      break;
    case TS_SHROOMS:
    default:
      strcpy(base,"earth\\");
      break;
    }
  strcpy(fullname,base);strcat(fullname,"grass.bmp");
	node[GRASS]=load_bitmap(fullname, NULL);
	strcpy(fullname,base);strcat(fullname,"generator.bmp");
	node[GEN]=load_bitmap(fullname, NULL);
	strcpy(fullname,base);strcat(fullname,"node.bmp");
	node[NODE]=load_bitmap(fullname, NULL);
	strcpy(fullname,base);strcat(fullname,"straight.bmp");
	node[HORIZ]=load_bitmap(fullname,NULL);
	strcpy(fullname,base);strcat(fullname,"four-way.bmp");
	node[FOUR]=load_bitmap(fullname,NULL);
	strcpy(fullname,base);strcat(fullname,"corner.bmp");
	node[DL]=load_bitmap(fullname,NULL);
	strcpy(fullname,base);strcat(fullname,"three-way.bmp");
	node[L3]=load_bitmap(fullname,NULL);
	strcpy(fullname,base);strcat(fullname,"background.bmp");
	bkg=load_bitmap(fullname,NULL);

	MAKE_ROT_MACRO(VERT,HORIZ,64);
	MAKE_ROT_MACRO(LU,DL,64);
	MAKE_ROT_MACRO(UR,DL,128);
	MAKE_ROT_MACRO(RD,DL,-64);
	MAKE_ROT_MACRO(U3,L3,64);
	MAKE_ROT_MACRO(R3,L3,128);
	MAKE_ROT_MACRO(D3,L3,-64);
	
	srand(time(NULL));
	for(int i=0;i<ROWS;i++)
		for(int j=0;j<COLS;j++)
			map[i][j]=GRASS;

	k=1 + (rand()%(ROWS-2));
	l=1 + (rand()%(COLS-2));
	map[k][l]=GEN;

	int works=0;
	int satisfied;
	int sum;
	for(int i=0;i<NUM_NODES;i++)
  	{
  	satisfied=0;
  	while(!satisfied)
  		{
  		m[i]=rand()%(ROWS-2);
  		n[i]=rand()%(COLS-2);

			sum=0;
 			for(int j=0;j<3;j++)
				for(int k=0;k<3;k++)
					sum+=M(m[i]+j,n[i]+k);
					
			if(sum==0)
				{	
				m[i]++;
				n[i]++;
				map[m[i]][n[i]]=NODE;
				satisfied=1;
				}
  		}
  	}	    
  buildpath();
	prune();
  makepathpretty();    	
	}

//count how many paths from tile -> choose which group of tiles to cycle through.
//check for NOT grass
//traverse through matrix and check left->right top->bottom
//if off screen connection, assume empty.

void makepathpretty()
  {
	int n,e,s,w;
	int ishappy=0;
	while(!ishappy)
  	{
		ishappy=1;
		for(int i=0;i<ROWS;i++){
			for(int j=0;j<COLS;j++)
			{
			if(map[i][j]==GRASS || map[i][j]==GEN || map[i][j]==NODE)
				continue;
			if(i>0)w=map[i-1][j]!=GRASS;
			else w=0;
			if(i<ROWS-1)e=map[i+1][j]!=GRASS;
			else e=0;
			if(j>0)n=map[i][j-1]!=GRASS;
			else n=0;
			if(j<COLS-1)s=map[i][j+1]!=GRASS;
			else s=0;
			if(n+s+e+w<=1)
				{
        map[i][j]=GRASS;
        ishappy=0;
        }
			}
		}
	for(int i=0;i<ROWS;i++)
		for(int j=0;j<COLS;j++)
  		{
  		if(map[i][j]==GRASS || map[i][j]==GEN || map[i][j]==NODE)
  			continue;
  		if(i>0)w=map[i-1][j]!=GRASS;
  		else w=0;
  		if(i<ROWS-1)e=map[i+1][j]!=GRASS;
  		else e=0;
  		if(j>0)n=map[i][j-1]!=GRASS;
  		else n=0;
  		if(j<COLS-1)s=map[i][j+1]!=GRASS;
  		else s=0;
  		switch (n+s+e+w)
  			{
  			case 4:
          map[i][j]=FOUR;
          break;
  			case 3:
  				if(!n) map[i][j]=D3;
  				else if(!s) map[i][j]=U3;
  				else if(!e) map[i][j]=L3;
  				else if(!w) map[i][j]=R3;
  				break;
  			case 2:
  				if(n && s) map[i][j]=VERT;
  				else if(e && w) map[i][j]=HORIZ;
  				else if(e && n) map[i][j]=UR;
  				else if(n && w) map[i][j]=LU;
  				else if(w && s) map[i][j]=DL;
  				else if(s && e) map[i][j]=RD;
  				break;
  			default:
  				break;
  			}		
      }
    }
  }

void buildpath()
  {
	int moved=0;
	for(int i=0;i<NUM_NODES;i++)
  	{
		while(k != m[i] || l != n[i])
  		{
			if(map[m[i]][n[i]]!=GEN)
  			{
				if(map[m[i]][n[i]]!=NODE) 
  				{
					if(map[m[i]][n[i]]==HORIZ && moved) 
            break;
					map[m[i]][n[i]]=HORIZ;
  				}
  			}
			if(k<m[i] && (rand()&1))
  			{
				m[i]--;
        moved=1;
  			}
			else if(k>m[i] && (rand()&1))
  			{
				m[i]++;
        moved=1;
  			}
			else if(l<n[i] && (rand()&1))
  			{
				n[i]--;
        moved=1;
  			}
			else if(l>n[i])
  			{
				n[i]++;
        moved=1;
  			}
			else
				moved=0;
  		}	
    }
  }

void prune()
  {
	for(int i=0;i<ROWS-2;i++)
		for(int j=0;j<COLS-1;j++)
  		{
			if(M(i,j)+M(i+1,j)+M(i+2,j)+
				M(i,j+1)+M(i+1,j+1)+M(i+2,j+1)==6)
  			{
				if(map[i+1][j]==HORIZ && rand()&1 && j>0 && map[i+1][j-1]==GRASS
             && map[i+1][j]!=GEN && map[i+1][j]!=NODE) // [CLD: added to avoid erasure]
					map[i+1][j]=GRASS;
				else if(map[i+1][j]==HORIZ && j<COLS-2 && map[i+1][j+2]==GRASS
             && map[i+1][j+1]!=GEN && map[i+1][j+1]!=NODE) // [CLD: added to avoid erasure]
					map[i+1][j+1]=GRASS;
  			}
  		}
	for(int i=0;i<ROWS-1;i++)
		for(int j=0;j<COLS-2;j++)
  		{
			if(M(i,j)+M(i+1,j)+
				M(i,j+1)+ M(i+1,j+1)+
				M(i,j+2)+M(i+1,j+2)==6)
  			{
				if(map[i][j+1]==HORIZ && rand()&1 && i>0 && map[i-1][j+1]==GRASS
             && map[i][j+1]!=GEN && map[i][j+1]!=NODE) // [CLD: added to avoid erasure]
					map[i][j+1]=GRASS;
				else if(map[i+1][j+1]==HORIZ && i<ROWS-2 && map[i+2][j+1]==GRASS
             && map[i+1][j+1]!=GEN && map[i+1][j+1]!=NODE) // [CLD: added to avoid erasure]
					map[i+1][j+1]=GRASS;
  			}
  		}
  }
